namespace :miners do
  task check_active_list: :environment do
    url = 'http://149.28.218.119:4243/active_list'
    response = HTTParty.get(url)

    response_json = JSON.parse(response.body)
    time = DateTime.new
    miners = Miner.all

    if response_json == []
      miners.each do |miner|
        miner.update(status: 'miss')
      end
    end

    miners.each do |miner|
      is_work = false
      hr_stats = 0
      check_activity_time = (DateTime.now - 5.minutes)

      response_json.each do |item|
        if item['work_id'] == miner.name
          is_work = true
          hr_stats = item["hr_stats"]
          break
        end
      end

      if is_work
        miner.update(status: 'work', hash_rate: hr_stats)
      else
        if miner.last_activity < check_activity_time
          miner.update(status: 'miss', last_activity: time, hash_rate: hr_stats)
        end
      end
    end
  end

  task get_miners_data: :environment do
    session = GoogleDrive::Session.from_service_account_key("client_secret.json")
    spreadsheet ||= session.spreadsheet_by_title("bsa_miners")
    @worksheet = spreadsheet.worksheets.first

    NAME = 1
    IP_ADDRESS = 4
    PORT = 5
    ADDRESS = 6
    PASS = 7
    ALGORITHM = 8
    IP_ADDRESS_2 = 9
    PORT_2 = 10
    ADDRESS_2 = 11
    PASS_2 = 12
    ALGORITHM_2 = 13

    row = 2
    col = 1

    @worksheet.rows.each_with_index do |cell, index|
      if @worksheet[index + row, NAME] == ""
        break
      end

      miner = Miner.find_by(name: @worksheet[index + row, NAME])
      if miner.present?
        miner.update(
          ip_address: @worksheet[index + row, IP_ADDRESS],
          port: @worksheet[index + row, PORT],
          wallet_address: @worksheet[index + row, ADDRESS],
          pass: @worksheet[index + row, PASS],
          algorithm: @worksheet[index + row, ALGORITHM],
          ip_address_2: @worksheet[index + row, IP_ADDRESS_2],
          port_2: @worksheet[index + row, PORT_2],
          wallet_address_2: @worksheet[index + row, ADDRESS_2],
          pass_2: @worksheet[index + row, PASS_2],
          algorithm_2: @worksheet[index + row, ALGORITHM_2])
      else
        Miner.create(
          name: @worksheet[index + row, NAME],
          ip_address: @worksheet[index + row, IP_ADDRESS],
          port: @worksheet[index + row, PORT],
          wallet_address: @worksheet[index + row, ADDRESS],
          pass: @worksheet[index + row, PASS],
          algorithm: @worksheet[index + row, ALGORITHM],
          ip_address_2: @worksheet[index + row, IP_ADDRESS_2],
          port_2: @worksheet[index + row, PORT_2],
          wallet_address_2: @worksheet[index + row, ADDRESS_2],
          pass_2: @worksheet[index + row, PASS_2],
          algorithm_2: @worksheet[index + row, ALGORITHM_2])
      end
    end
  end
end